searchNodes=[{"ref":"Bonny.html","title":"Bonny","module":"Bonny","type":"module","doc":"Extend the Kubernetes API and implement CustomResourceDefinitions lifecycles in Elixir."},{"ref":"Bonny.CRD.html","title":"Bonny.CRD","module":"Bonny.CRD","type":"module","doc":"Represents the spec portion of a Kubernetes CustomResourceDefinition manifest. The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource."},{"ref":"Bonny.CRD.html#api_version/1","title":"Bonny.CRD.api_version/1","module":"Bonny.CRD","type":"function","doc":"Gets group version from CRD spec Examples Returns apiVersion for an operator iex&gt; Bonny.CRD.api_version(%Bonny.CRD{group: &quot;hello.example.com&quot;, version: &quot;v1&quot;, scope: :namespaced, names: %{}}) &quot;hello.example.com/v1&quot; Returns apiVersion for apps resources iex&gt; Bonny.CRD.api_version(%Bonny.CRD{group: &quot;apps&quot;, version: &quot;v1&quot;, scope: :namespaced, names: %{}}) &quot;apps/v1&quot; Returns apiVersion for core resources iex&gt; Bonny.CRD.api_version(%Bonny.CRD{group: &quot;&quot;, version: &quot;v1&quot;, scope: :namespaced, names: %{}}) &quot;v1&quot; iex&gt; Bonny.CRD.api_version(%Bonny.CRD{group: nil, version: &quot;v1&quot;, scope: :namespaced, names: %{}}) &quot;v1&quot;"},{"ref":"Bonny.CRD.html#default_columns/0","title":"Bonny.CRD.default_columns/0","module":"Bonny.CRD","type":"function","doc":"Default CLI printer columns. These are added to the CRDs columns when columns are set. The kubernetes API returns these by default when they are not set."},{"ref":"Bonny.CRD.html#kind/1","title":"Bonny.CRD.kind/1","module":"Bonny.CRD","type":"function","doc":"CRD Kind or plural name Examples iex&gt; Bonny.CRD.kind(%Bonny.CRD{names: %{plural: &quot;greetings&quot;}, scope: :namespaced, group: &quot;test&quot;, version: &quot;v1&quot;}) &quot;greetings&quot;"},{"ref":"Bonny.CRD.html#to_manifest/1","title":"Bonny.CRD.to_manifest/1","module":"Bonny.CRD","type":"function","doc":"Generates the map equivalent of the Kubernetes CRD YAML manifest --- apiVersion: apiextensions.k8s.io/v1beta1 kind: CustomResourceDefinition metadata: creationTimestamp: null name: widgets.example.com spec: group: example.com names: kind: Widget plural: widgets scope: Namespaced version: v1"},{"ref":"Bonny.CRD.html#t:t/0","title":"Bonny.CRD.t/0","module":"Bonny.CRD","type":"type","doc":"CRD Spec"},{"ref":"Bonny.Config.html","title":"Bonny.Config","module":"Bonny.Config","type":"module","doc":"Operator configuration interface"},{"ref":"Bonny.Config.html#cluster_name/0","title":"Bonny.Config.cluster_name/0","module":"Bonny.Config","type":"function","doc":"K8s.Cluster name used for this operator. Defaults to :default"},{"ref":"Bonny.Config.html#controllers/0","title":"Bonny.Config.controllers/0","module":"Bonny.Config","type":"function","doc":"List of all controller modules to watch. This must be set in config.exs: config :bonny, controllers: [MyController1, MyController2]"},{"ref":"Bonny.Config.html#group/0","title":"Bonny.Config.group/0","module":"Bonny.Config","type":"function","doc":"Kubernetes API Group of this operator"},{"ref":"Bonny.Config.html#labels/0","title":"Bonny.Config.labels/0","module":"Bonny.Config","type":"function","doc":"Labels to apply to all operator resources. Note: These are only applied to the resoures that compose the operator itself, not the resources created by the operator. This can be set in config.exs: config :bonny, labels: %{foo: &quot;bar&quot;, quz: &quot;baz&quot;}"},{"ref":"Bonny.Config.html#name/0","title":"Bonny.Config.name/0","module":"Bonny.Config","type":"function","doc":"The name of the operator. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator"},{"ref":"Bonny.Config.html#namespace/0","title":"Bonny.Config.namespace/0","module":"Bonny.Config","type":"function","doc":"The namespace to watch for Namespaced CRDs. Defaults to default This can be set via environment variable: BONNY_POD_NAMESPACE=prod iex -S mix Bonny sets BONNY_POD_NAMESPACE on all Kubernetes deployments to the namespace the operator is deployed in."},{"ref":"Bonny.Config.html#service_account/0","title":"Bonny.Config.service_account/0","module":"Bonny.Config","type":"function","doc":"Kubernetes service account name to run operator as. Note: if a kube config file is provided, this service account will still be created and assigned to pods, but the config file auth will be used when making requests to the Kube API. Name must consist of only lowercase letters and hyphens. Defaults to hyphenated mix project app name. E.g.: :hello_operator becomes hello-operator"},{"ref":"Bonny.Controller.html","title":"Bonny.Controller","module":"Bonny.Controller","type":"behaviour","doc":"Bonny.Controller defines controller behaviours and generates boilerplate for generating Kubernetes manifests. A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Controllers allow for simple add, modify, delete, and reconcile handling of custom resources in the Kubernetes API."},{"ref":"Bonny.Controller.html#c:add/1","title":"Bonny.Controller.add/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:delete/1","title":"Bonny.Controller.delete/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:modify/1","title":"Bonny.Controller.modify/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Controller.html#c:reconcile/1","title":"Bonny.Controller.reconcile/1","module":"Bonny.Controller","type":"callback","doc":""},{"ref":"Bonny.Naming.html","title":"Bonny.Naming","module":"Bonny.Naming","type":"module","doc":"Naming functions"},{"ref":"Bonny.Naming.html#module_to_kind/1","title":"Bonny.Naming.module_to_kind/1","module":"Bonny.Naming","type":"function","doc":"Converts an elixir module name to a string for use as the CRD&#39;s kind. Examples iex&gt; Bonny.Naming.module_to_kind(Pod) &quot;Pod&quot; iex&gt; Bonny.Naming.module_to_kind(Controllers.V1.Pod) &quot;Pod&quot;"},{"ref":"Bonny.Naming.html#module_version/1","title":"Bonny.Naming.module_version/1","module":"Bonny.Naming","type":"function","doc":"Extract the CRD API version from the module name. Defaults to &quot;v1&quot; Examples iex&gt; Bonny.Naming.module_version(Pod) &quot;v1&quot; iex&gt; Bonny.Naming.module_version(Controllers.V1.Pod) &quot;v1&quot; iex&gt; Bonny.Naming.module_version(Controllers.V1Alpha1.Pod) &quot;v1alpha1&quot;"},{"ref":"Bonny.Operator.html","title":"Bonny.Operator","module":"Bonny.Operator","type":"module","doc":"Encapsulates Kubernetes resource manifests for an operator"},{"ref":"Bonny.Operator.html#cluster_role/0","title":"Bonny.Operator.cluster_role/0","module":"Bonny.Operator","type":"function","doc":"ClusterRole manifest"},{"ref":"Bonny.Operator.html#cluster_role_binding/1","title":"Bonny.Operator.cluster_role_binding/1","module":"Bonny.Operator","type":"function","doc":"ClusterRoleBinding manifest"},{"ref":"Bonny.Operator.html#crds/0","title":"Bonny.Operator.crds/0","module":"Bonny.Operator","type":"function","doc":"CRD manifests"},{"ref":"Bonny.Operator.html#deployment/2","title":"Bonny.Operator.deployment/2","module":"Bonny.Operator","type":"function","doc":"Deployment manifest"},{"ref":"Bonny.Operator.html#rules/0","title":"Bonny.Operator.rules/0","module":"Bonny.Operator","type":"function","doc":"ClusterRole rules"},{"ref":"Bonny.Operator.html#service_account/1","title":"Bonny.Operator.service_account/1","module":"Bonny.Operator","type":"function","doc":"ServiceAccount manifest"},{"ref":"Bonny.PeriodicTask.html","title":"Bonny.PeriodicTask","module":"Bonny.PeriodicTask","type":"module","doc":"Register periodically run tasks. Use for running tasks as a part of reconciling a CRD with a lifetime, duration, or interval field. Note: Must be started by your operator. Add Bonny.PeriodicTask.sttart_link(:ok) to your application. Functions are expected to return one of: :ok - task will be passed to subsequent calls {:ok, new_state} state field will be updated in task and provided to next call {:stop, reason} task will be removed from execution loop. Use for tasks opting out of being re-run any() - any other result is treated as an error, and the execution loop will be halted Examples Registering a task iex&gt; Bonny.PeriodicTask.new(:pod_evictor, {PodEvictor, :evict, [reconcile_payload_map]}, 5000) Unregistering a task iex&gt; Bonny.PeriodicTask.unregister(:pod_evictor)"},{"ref":"Bonny.PeriodicTask.html#child_spec/1","title":"Bonny.PeriodicTask.child_spec/1","module":"Bonny.PeriodicTask","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Bonny.PeriodicTask.html#new/3","title":"Bonny.PeriodicTask.new/3","module":"Bonny.PeriodicTask","type":"function","doc":"Registers and starts a new task given Bonny.PeriodicTask attributes"},{"ref":"Bonny.PeriodicTask.html#register/1","title":"Bonny.PeriodicTask.register/1","module":"Bonny.PeriodicTask","type":"function","doc":"Registers and starts a new Bonny.PeriodicTask"},{"ref":"Bonny.PeriodicTask.html#start_link/1","title":"Bonny.PeriodicTask.start_link/1","module":"Bonny.PeriodicTask","type":"function","doc":""},{"ref":"Bonny.PeriodicTask.html#unregister/1","title":"Bonny.PeriodicTask.unregister/1","module":"Bonny.PeriodicTask","type":"function","doc":"Unregisters and stops a Bonny.PeriodicTask"},{"ref":"Bonny.PeriodicTask.html#t:t/0","title":"Bonny.PeriodicTask.t/0","module":"Bonny.PeriodicTask","type":"type","doc":""},{"ref":"Bonny.Server.Reconciler.html","title":"Bonny.Server.Reconciler","module":"Bonny.Server.Reconciler","type":"behaviour","doc":"Continuously reconciles a set of kubernetes resources. reconcile/1 will be executed asynchronously with each result returned from reconcilable_resources/0. reconcilable_resources/0 has a default implementation of running K8s.Client.stream/2 with reconcile_operation/0. For a working example of the Reconciler see Bonny.Server.Scheduler Examples Print every pod. Not very useful, but a simple copy-paste example. defmodule PodPrinterReconciler do use Bonny.Server.Reconciler, frequency: 15 @impl true def reconcile(pod) do IO.inspect(pod) :ok end @impl true def reconcile_operation(), do: K8s.Client.list(&quot;v1&quot;, :pods, namespace: &quot;default&quot;) @impl true def reconcilable_resources() do operation = reconcile_operation() cluster = Bonny.Config.cluster_name() K8s.Client.stream(operation, cluster) end end PodPrinterReconciler.start_link() A quick and dirty chaos monkey for pods. 20% chance of eviction every 15 seconds. defmodule ChaosMonkeyReconciler do use Bonny.Server.Reconciler, frequency: 15 @percent_chance_evicted 20 @impl true def reconcile(pod) do chance = :rand.uniform(100) if chance &lt; @percent_chance_evicted do my_function_to_evict_pod(pod) end :ok end @impl true def reconcile_operation(), do: K8s.Client.list(&quot;v1&quot;, :pods, namespace: :all) @impl true def reconcilable_resources() do operation = reconcile_operation() cluster = Bonny.Config.cluster_name() K8s.Client.stream(operation, cluster) end end ChaosMonkeyReconciler.start_link() Reconcile a CRD&#39;s resources every 15 seconds defmodule MyCustomResourceReconciler do use Bonny.Server.Reconciler, frequency: 15 @impl true def reconcile(resource) do # You should do something much cooler than inspect here... IO.inspect(resource) :ok end @impl true def reconcile_operation() do K8s.Client.list(&quot;example.com/v1&quot;, &quot;MyCustomResourceDef&quot;, namespace: :all) end @impl true def reconcilable_resources() do operation = reconcile_operation() cluster = Bonny.Config.cluster_name() K8s.Client.stream(operation, cluster) end end MyCustomResourceReconciler.start_link()"},{"ref":"Bonny.Server.Reconciler.html#c:reconcilable_resources/0","title":"Bonny.Server.Reconciler.reconcilable_resources/0","module":"Bonny.Server.Reconciler","type":"callback","doc":"(Optional) List of resources to be reconciled. Default implementation is to stream all resources (reconcile_operation/0) from the cluster (Bonny.Config.cluster_name/0)."},{"ref":"Bonny.Server.Reconciler.html#c:reconcile/1","title":"Bonny.Server.Reconciler.reconcile/1","module":"Bonny.Server.Reconciler","type":"callback","doc":"Reconciles a resource. This will receive a list of resources from reconcilable_resources/0."},{"ref":"Bonny.Server.Reconciler.html#c:reconcile_operation/0","title":"Bonny.Server.Reconciler.reconcile_operation/0","module":"Bonny.Server.Reconciler","type":"callback","doc":"K8s.Operation to reconcile. Examples def reconcile_operation() do K8s.Client.list(&quot;v1&quot;, :pods, namespace: :all) end"},{"ref":"Bonny.Server.Reconciler.html#run/1","title":"Bonny.Server.Reconciler.run/1","module":"Bonny.Server.Reconciler","type":"function","doc":"Runs a Reconcilers reconcile/1 for each resource return by reconcilable_resources/0"},{"ref":"Bonny.Server.Reconciler.html#schedule/2","title":"Bonny.Server.Reconciler.schedule/2","module":"Bonny.Server.Reconciler","type":"function","doc":"Schedules a run of a started Reconciler"},{"ref":"Bonny.Server.Scheduler.html","title":"Bonny.Server.Scheduler","module":"Bonny.Server.Scheduler","type":"behaviour","doc":"Kubernetes custom scheduler interface. Built on top of Reconciler. The only function that needs to be implemented is select_node_for_pod/2. All others defined by behaviour have default implementations. Examples Will schedule each unschedule pod with spec.schedulerName=cheap-node to a node with a label cheap=true. nodes is a stream that can be lazily filtered: defmodule CheapNodeScheduler do use Bonny.Server.Scheduler, name: &quot;cheap-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod(_pod, nodes) do nodes |&gt; Stream.filter(fn(node) -&gt; is_cheap = K8s.Resource.label(node, &quot;cheap&quot;) is_cheap == &quot;true&quot; end) |&gt; Enum.take(1) |&gt; List.first end end CheapNodeScheduler.start_link() Will schedule each unschedule pod with spec.schedulerName=random-node to a random node: defmodule RandomNodeScheduler do use Bonny.Server.Scheduler, name: &quot;random-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod(_pod, nodes) do Enum.random(nodes) end end RandomNodeScheduler.start_link() Override nodes/0 default implementation (pods/0 can be overridden too). Schedules pod on a random GPU node: defmodule GpuScheduler do use Bonny.Server.Scheduler, name: &quot;gpu-node&quot; @impl Bonny.Server.Scheduler def select_node_for_pod(_pod, nodes) do Enum.random(nodes) end @impl Bonny.Server.Scheduler def nodes() do label = &quot;my.label.on.gpu.instances&quot; cluster = Bonny.Config.cluster_name() op = K8s.Client.list(&quot;v1&quot;, :nodes) K8s.Client.stream(op, cluster, params: %{labelSelector: label}) end end GpuScheduler.start_link()"},{"ref":"Bonny.Server.Scheduler.html#bind/2","title":"Bonny.Server.Scheduler.bind/2","module":"Bonny.Server.Scheduler","type":"function","doc":"Binds a pod to a node"},{"ref":"Bonny.Server.Scheduler.html#c:field_selector/0","title":"Bonny.Server.Scheduler.field_selector/0","module":"Bonny.Server.Scheduler","type":"callback","doc":"Field selector for selecting unscheduled pods waiting to be scheduled by this scheduler. Default implementation is all unscheduled pods assigned to this scheduler."},{"ref":"Bonny.Server.Scheduler.html#field_selector/1","title":"Bonny.Server.Scheduler.field_selector/1","module":"Bonny.Server.Scheduler","type":"function","doc":"Kubernetes API fieldSelector value for unbound pods waiting on the given scheduler."},{"ref":"Bonny.Server.Scheduler.html#c:name/0","title":"Bonny.Server.Scheduler.name/0","module":"Bonny.Server.Scheduler","type":"callback","doc":"Name of the scheduler."},{"ref":"Bonny.Server.Scheduler.html#nodes/0","title":"Bonny.Server.Scheduler.nodes/0","module":"Bonny.Server.Scheduler","type":"function","doc":"Returns a list of all nodes in the cluster."},{"ref":"Bonny.Server.Scheduler.html#c:nodes/0","title":"Bonny.Server.Scheduler.nodes/0","module":"Bonny.Server.Scheduler","type":"callback","doc":"List of nodes available to this scheduler. Default implementation is all nodes in cluster."},{"ref":"Bonny.Server.Scheduler.html#c:pods/0","title":"Bonny.Server.Scheduler.pods/0","module":"Bonny.Server.Scheduler","type":"callback","doc":"List of unscheduled pods awaiting this scheduler. Default implementation is all unscheduled pods specifying this scheduler in spec.schedulerName."},{"ref":"Bonny.Server.Scheduler.html#pods/1","title":"Bonny.Server.Scheduler.pods/1","module":"Bonny.Server.Scheduler","type":"function","doc":"Returns a list of pods for the given field_selector."},{"ref":"Bonny.Server.Scheduler.html#c:select_node_for_pod/2","title":"Bonny.Server.Scheduler.select_node_for_pod/2","module":"Bonny.Server.Scheduler","type":"callback","doc":"Selects the best node for the current pod. Takes the current unscheduled pod and a Stream of nodes. pod is provided in the event that taints or affinities would need to be respected by the scheduler. Returns the node to schedule on."},{"ref":"Bonny.Server.Scheduler.Binding.html","title":"Bonny.Server.Scheduler.Binding","module":"Bonny.Server.Scheduler.Binding","type":"module","doc":"Kubernetes binding interface. Currently undocumented in Kubernetes docs. Links Example using curl Example using golang"},{"ref":"Bonny.Server.Scheduler.Binding.html#create/2","title":"Bonny.Server.Scheduler.Binding.create/2","module":"Bonny.Server.Scheduler.Binding","type":"function","doc":"Performs a POST HTTP request against the pod&#39;s binding subresource. /api/v1/namespaces/{NAMESPACE}/pods/{POD}/binding"},{"ref":"Bonny.Server.Scheduler.Binding.html#new/2","title":"Bonny.Server.Scheduler.Binding.new/2","module":"Bonny.Server.Scheduler.Binding","type":"function","doc":"Returns a map representing a Binding kubernetes resource Example iex&gt; pod = %{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}} ...&gt; node = %{&quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;kewl-node&quot;}} iex&gt; Bonny.Server.Scheduler.Binding.new(pod, node) %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Binding&quot;, &quot;metadata&quot; =&gt; %{&quot;name&quot; =&gt; &quot;nginx&quot;, &quot;namespace&quot; =&gt; &quot;default&quot;}, &quot;target&quot; =&gt; %{&quot;apiVersion&quot; =&gt; &quot;v1&quot;, &quot;kind&quot; =&gt; &quot;Node&quot;, &quot;name&quot; =&gt; &quot;kewl-node&quot;}}"},{"ref":"Bonny.Server.Watcher.html","title":"Bonny.Server.Watcher","module":"Bonny.Server.Watcher","type":"behaviour","doc":"Continuously watch a list Operation for add, modify, and delete events."},{"ref":"Bonny.Server.Watcher.html#c:add/1","title":"Bonny.Server.Watcher.add/1","module":"Bonny.Server.Watcher","type":"callback","doc":""},{"ref":"Bonny.Server.Watcher.html#c:delete/1","title":"Bonny.Server.Watcher.delete/1","module":"Bonny.Server.Watcher","type":"callback","doc":""},{"ref":"Bonny.Server.Watcher.html#dispatch/2","title":"Bonny.Server.Watcher.dispatch/2","module":"Bonny.Server.Watcher","type":"function","doc":"Dispatches an ADDED, MODIFIED, and DELETED events to an controller"},{"ref":"Bonny.Server.Watcher.html#c:modify/1","title":"Bonny.Server.Watcher.modify/1","module":"Bonny.Server.Watcher","type":"callback","doc":""},{"ref":"Bonny.Server.Watcher.html#process_line/3","title":"Bonny.Server.Watcher.process_line/3","module":"Bonny.Server.Watcher","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.html#process_lines/3","title":"Bonny.Server.Watcher.process_lines/3","module":"Bonny.Server.Watcher","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.html#watch/3","title":"Bonny.Server.Watcher.watch/3","module":"Bonny.Server.Watcher","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.html#c:watch_operation/0","title":"Bonny.Server.Watcher.watch_operation/0","module":"Bonny.Server.Watcher","type":"callback","doc":"K8s.Operation to watch. Examples Log all pod lifecycle events defmodule PodLifecycleLogger do use Bonny.Server.Watcher @impl true def watch_operation() do K8s.Client.list(&quot;v1&quot;, :pods, namespace: :all) end @impl true def add(pod) do log_event(:add, pod) end @impl true def modify(pod) do log_event(:modify, pod) end @impl true def delete(pod) do log_event(:delete, pod) end @spec log_event(atom, map) :: :ok def log_event(type, pod) do name = get_in(pod, [&quot;metadata&quot;, &quot;name&quot;]) namespace = get_in(pod, [&quot;metadata&quot;, &quot;namepace&quot;]) || &quot;default&quot; # log type,name,namespace here end end"},{"ref":"Bonny.Server.Watcher.ResourceVersion.html","title":"Bonny.Server.Watcher.ResourceVersion","module":"Bonny.Server.Watcher.ResourceVersion","type":"module","doc":"Get the resourceVersion for a K8s.Operation"},{"ref":"Bonny.Server.Watcher.ResourceVersion.html#extract_rv/1","title":"Bonny.Server.Watcher.ResourceVersion.extract_rv/1","module":"Bonny.Server.Watcher.ResourceVersion","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.ResourceVersion.html#get/1","title":"Bonny.Server.Watcher.ResourceVersion.get/1","module":"Bonny.Server.Watcher.ResourceVersion","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.ResponseBuffer.html","title":"Bonny.Server.Watcher.ResponseBuffer","module":"Bonny.Server.Watcher.ResponseBuffer","type":"module","doc":"Buffers streaming responses from HTTPoison and returns kubernetes watch events as JSON ResponseBuffer implementation from Kazan&#39;s LineBuffer."},{"ref":"Bonny.Server.Watcher.ResponseBuffer.html#add_chunk/2","title":"Bonny.Server.Watcher.ResponseBuffer.add_chunk/2","module":"Bonny.Server.Watcher.ResponseBuffer","type":"function","doc":"Add an HTTP response chunk to the buffer"},{"ref":"Bonny.Server.Watcher.ResponseBuffer.html#get_lines/1","title":"Bonny.Server.Watcher.ResponseBuffer.get_lines/1","module":"Bonny.Server.Watcher.ResponseBuffer","type":"function","doc":"Returns complete lines of JSON from streaming HTTP Response. Lines are in NDJSON format; each line is a JSON object."},{"ref":"Bonny.Server.Watcher.ResponseBuffer.html#new/0","title":"Bonny.Server.Watcher.ResponseBuffer.new/0","module":"Bonny.Server.Watcher.ResponseBuffer","type":"function","doc":"Create a new ResponseBuffer"},{"ref":"Bonny.Server.Watcher.ResponseBuffer.html#t:t/0","title":"Bonny.Server.Watcher.ResponseBuffer.t/0","module":"Bonny.Server.Watcher.ResponseBuffer","type":"type","doc":""},{"ref":"Bonny.Server.Watcher.State.html","title":"Bonny.Server.Watcher.State","module":"Bonny.Server.Watcher.State","type":"module","doc":"State of the Watcher"},{"ref":"Bonny.Server.Watcher.State.html#new/0","title":"Bonny.Server.Watcher.State.new/0","module":"Bonny.Server.Watcher.State","type":"function","doc":""},{"ref":"Bonny.Server.Watcher.State.html#t:t/0","title":"Bonny.Server.Watcher.State.t/0","module":"Bonny.Server.Watcher.State","type":"type","doc":""},{"ref":"Bonny.Sys.Event.html","title":"Bonny.Sys.Event","module":"Bonny.Sys.Event","type":"module","doc":"Bonny.Sys.Event is a thin wrapper around :telemetry. All events will be prefixed with bonny. The following events are emitted: [:bonny, :task, :stopped] [:bonny, :task, :failed] [:bonny, :task, :succeeded] [:bonny, :task, :unregistered] [:bonny, :task, :registered] [:bonny, :task, :initialized] [:bonny, :scheduler, :binding, :failed] [:bonny, :scheduler, :binding, :succeeded] [:bonny, :scheduler, :nodes, :fetch, :failed] [:bonny, :scheduler, :nodes, :fetch, :succeeded] [:bonny, :scheduler, :pods, :fetch, :failed] [:bonny, :scheduler, :pods, :fetch, :succeeded] [:bonny, :reconciler, :genserver, :down] [:bonny, :reconciler, :reconcile, :failed] [:bonny, :reconciler, :reconcile, :succeeded] [:bonny, :reconciler, :run, :started] [:bonny, :reconciler, :fetch, :failed] [:bonny, :reconciler, :fetch, :succeeded] [:bonny, :reconciler, :initialized] [:bonny, :watcher, :genserver, :down] [:bonny, :watcher, :chunk, :received] [:bonny, :watcher, :watch, :timedout] [:bonny, :watcher, :watch, :failed] [:bonny, :watcher, :watch, :finished] [:bonny, :watcher, :watch, :succeeded] [:bonny, :watcher, :watch, :started] [:bonny, :watcher, :initialized] To access this list programmatically use events/0. If set, default metadata will be applied to all events. See: metadata/0"},{"ref":"Bonny.Sys.Event.html#events/0","title":"Bonny.Sys.Event.events/0","module":"Bonny.Sys.Event","type":"function","doc":"Returns a list of all events emitted by this module: [:bonny, :task, :stopped] [:bonny, :task, :failed] [:bonny, :task, :succeeded] [:bonny, :task, :unregistered] [:bonny, :task, :registered] [:bonny, :task, :initialized] [:bonny, :scheduler, :binding, :failed] [:bonny, :scheduler, :binding, :succeeded] [:bonny, :scheduler, :nodes, :fetch, :failed] [:bonny, :scheduler, :nodes, :fetch, :succeeded] [:bonny, :scheduler, :pods, :fetch, :failed] [:bonny, :scheduler, :pods, :fetch, :succeeded] [:bonny, :reconciler, :genserver, :down] [:bonny, :reconciler, :reconcile, :failed] [:bonny, :reconciler, :reconcile, :succeeded] [:bonny, :reconciler, :run, :started] [:bonny, :reconciler, :fetch, :failed] [:bonny, :reconciler, :fetch, :succeeded] [:bonny, :reconciler, :initialized] [:bonny, :watcher, :genserver, :down] [:bonny, :watcher, :chunk, :received] [:bonny, :watcher, :watch, :timedout] [:bonny, :watcher, :watch, :failed] [:bonny, :watcher, :watch, :finished] [:bonny, :watcher, :watch, :succeeded] [:bonny, :watcher, :watch, :started] [:bonny, :watcher, :initialized] Great for use with :telemetry.attach_many/4"},{"ref":"Bonny.Sys.Event.html#measure/3","title":"Bonny.Sys.Event.measure/3","module":"Bonny.Sys.Event","type":"function","doc":"Measure function execution in ms and return in map w/ results. Examples iex&gt; Bonny.Sys.Event.measure(IO, :puts, [&quot;hello&quot;]) {%{duration: 33}, :ok}"},{"ref":"Bonny.Sys.Event.html#metadata/0","title":"Bonny.Sys.Event.metadata/0","module":"Bonny.Sys.Event","type":"function","doc":"Default metadata added to all events. Defaults: %{}"},{"ref":"Bonny.Sys.Event.html#metadata/1","title":"Bonny.Sys.Event.metadata/1","module":"Bonny.Sys.Event","type":"function","doc":"Merges metadata with defaults"},{"ref":"Bonny.Sys.Event.html#name/0","title":"Bonny.Sys.Event.name/0","module":"Bonny.Sys.Event","type":"function","doc":"The instrumenter name"},{"ref":"Bonny.Sys.Event.html#reconciler_fetch_failed/2","title":"Bonny.Sys.Event.reconciler_fetch_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_fetch_succeeded/2","title":"Bonny.Sys.Event.reconciler_fetch_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_genserver_down/2","title":"Bonny.Sys.Event.reconciler_genserver_down/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_initialized/2","title":"Bonny.Sys.Event.reconciler_initialized/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_reconcile_failed/2","title":"Bonny.Sys.Event.reconciler_reconcile_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_reconcile_succeeded/2","title":"Bonny.Sys.Event.reconciler_reconcile_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#reconciler_run_started/2","title":"Bonny.Sys.Event.reconciler_run_started/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_binding_failed/2","title":"Bonny.Sys.Event.scheduler_binding_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_binding_succeeded/2","title":"Bonny.Sys.Event.scheduler_binding_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_nodes_fetch_failed/2","title":"Bonny.Sys.Event.scheduler_nodes_fetch_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_nodes_fetch_succeeded/2","title":"Bonny.Sys.Event.scheduler_nodes_fetch_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_pods_fetch_failed/2","title":"Bonny.Sys.Event.scheduler_pods_fetch_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#scheduler_pods_fetch_succeeded/2","title":"Bonny.Sys.Event.scheduler_pods_fetch_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_failed/2","title":"Bonny.Sys.Event.task_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_initialized/2","title":"Bonny.Sys.Event.task_initialized/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_registered/2","title":"Bonny.Sys.Event.task_registered/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_stopped/2","title":"Bonny.Sys.Event.task_stopped/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_succeeded/2","title":"Bonny.Sys.Event.task_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#task_unregistered/2","title":"Bonny.Sys.Event.task_unregistered/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_chunk_received/2","title":"Bonny.Sys.Event.watcher_chunk_received/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_genserver_down/2","title":"Bonny.Sys.Event.watcher_genserver_down/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_initialized/2","title":"Bonny.Sys.Event.watcher_initialized/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_watch_failed/2","title":"Bonny.Sys.Event.watcher_watch_failed/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_watch_finished/2","title":"Bonny.Sys.Event.watcher_watch_finished/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_watch_started/2","title":"Bonny.Sys.Event.watcher_watch_started/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_watch_succeeded/2","title":"Bonny.Sys.Event.watcher_watch_succeeded/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Event.html#watcher_watch_timedout/2","title":"Bonny.Sys.Event.watcher_watch_timedout/2","module":"Bonny.Sys.Event","type":"function","doc":""},{"ref":"Bonny.Sys.Logger.html","title":"Bonny.Sys.Logger","module":"Bonny.Sys.Logger","type":"module","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"Bonny.Sys.Logger.html#attach/0","title":"Bonny.Sys.Logger.attach/0","module":"Bonny.Sys.Logger","type":"function","doc":"Attaches telemetry events to the Elixir Logger"},{"ref":"DeploymentEventLogController.html","title":"DeploymentEventLogController","module":"DeploymentEventLogController","type":"module","doc":"This is a goofy config, but it makes this work in dev w/o having to POST an Example CRD. This controller simply logs lifecycle events on Deployments."},{"ref":"DeploymentEventLogController.html#child_spec/1","title":"DeploymentEventLogController.child_spec/1","module":"DeploymentEventLogController","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"DeploymentEventLogController.html#crd/0","title":"DeploymentEventLogController.crd/0","module":"DeploymentEventLogController","type":"function","doc":"Returns the Bonny.CRD.t() the controller manages the lifecycle of."},{"ref":"DeploymentEventLogController.html#list_operation/0","title":"DeploymentEventLogController.list_operation/0","module":"DeploymentEventLogController","type":"function","doc":""},{"ref":"DeploymentEventLogController.html#rules/0","title":"DeploymentEventLogController.rules/0","module":"DeploymentEventLogController","type":"function","doc":"A list of RBAC rules that this controller needs to operate. This list will be serialized into the operator manifest when using mix bonny.gen.manifest."},{"ref":"DeploymentEventLogController.html#start_link/1","title":"DeploymentEventLogController.start_link/1","module":"DeploymentEventLogController","type":"function","doc":""},{"ref":"DeploymentEventLogController.html#track_event/2","title":"DeploymentEventLogController.track_event/2","module":"DeploymentEventLogController","type":"function","doc":""},{"ref":"DeploymentEventLogController.ReconcileServer.html","title":"DeploymentEventLogController.ReconcileServer","module":"DeploymentEventLogController.ReconcileServer","type":"module","doc":"Controller reconciler implementation"},{"ref":"DeploymentEventLogController.ReconcileServer.html#child_spec/1","title":"DeploymentEventLogController.ReconcileServer.child_spec/1","module":"DeploymentEventLogController.ReconcileServer","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"DeploymentEventLogController.ReconcileServer.html#reconcile/1","title":"DeploymentEventLogController.ReconcileServer.reconcile/1","module":"DeploymentEventLogController.ReconcileServer","type":"function","doc":"Reconciles a resource. This will receive a list of resources from reconcilable_resources/0. Callback implementation for Bonny.Server.Reconciler.reconcile/1."},{"ref":"DeploymentEventLogController.ReconcileServer.html#reconcile_operation/0","title":"DeploymentEventLogController.ReconcileServer.reconcile_operation/0","module":"DeploymentEventLogController.ReconcileServer","type":"function","doc":"K8s.Operation to reconcile. Examples def reconcile_operation() do K8s.Client.list(&quot;v1&quot;, :pods, namespace: :all) end Callback implementation for Bonny.Server.Reconciler.reconcile_operation/0."},{"ref":"DeploymentEventLogController.ReconcileServer.html#start_link/0","title":"DeploymentEventLogController.ReconcileServer.start_link/0","module":"DeploymentEventLogController.ReconcileServer","type":"function","doc":""},{"ref":"DeploymentEventLogController.ReconcileServer.html#start_link/1","title":"DeploymentEventLogController.ReconcileServer.start_link/1","module":"DeploymentEventLogController.ReconcileServer","type":"function","doc":""},{"ref":"DeploymentEventLogController.WatchServer.html","title":"DeploymentEventLogController.WatchServer","module":"DeploymentEventLogController.WatchServer","type":"module","doc":"Controller watcher implementation"},{"ref":"DeploymentEventLogController.WatchServer.html#add/1","title":"DeploymentEventLogController.WatchServer.add/1","module":"DeploymentEventLogController.WatchServer","type":"function","doc":"Callback implementation for Bonny.Server.Watcher.add/1."},{"ref":"DeploymentEventLogController.WatchServer.html#child_spec/1","title":"DeploymentEventLogController.WatchServer.child_spec/1","module":"DeploymentEventLogController.WatchServer","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"DeploymentEventLogController.WatchServer.html#delete/1","title":"DeploymentEventLogController.WatchServer.delete/1","module":"DeploymentEventLogController.WatchServer","type":"function","doc":"Callback implementation for Bonny.Server.Watcher.delete/1."},{"ref":"DeploymentEventLogController.WatchServer.html#modify/1","title":"DeploymentEventLogController.WatchServer.modify/1","module":"DeploymentEventLogController.WatchServer","type":"function","doc":"Callback implementation for Bonny.Server.Watcher.modify/1."},{"ref":"DeploymentEventLogController.WatchServer.html#start_link/0","title":"DeploymentEventLogController.WatchServer.start_link/0","module":"DeploymentEventLogController.WatchServer","type":"function","doc":""},{"ref":"DeploymentEventLogController.WatchServer.html#start_link/1","title":"DeploymentEventLogController.WatchServer.start_link/1","module":"DeploymentEventLogController.WatchServer","type":"function","doc":""},{"ref":"DeploymentEventLogController.WatchServer.html#watch_operation/0","title":"DeploymentEventLogController.WatchServer.watch_operation/0","module":"DeploymentEventLogController.WatchServer","type":"function","doc":"K8s.Operation to watch. Examples Log all pod lifecycle events defmodule PodLifecycleLogger do use Bonny.Server.Watcher @impl true def watch_operation() do K8s.Client.list(&quot;v1&quot;, :pods, namespace: :all) end @impl true def add(pod) do log_event(:add, pod) end @impl true def modify(pod) do log_event(:modify, pod) end @impl true def delete(pod) do log_event(:delete, pod) end @spec log_event(atom, map) :: :ok def log_event(type, pod) do name = get_in(pod, [&quot;metadata&quot;, &quot;name&quot;]) namespace = get_in(pod, [&quot;metadata&quot;, &quot;namepace&quot;]) || &quot;default&quot; # log type,name,namespace here end end Callback implementation for Bonny.Server.Watcher.watch_operation/0."},{"ref":"Mix.Bonny.html","title":"Mix.Bonny","module":"Mix.Bonny","type":"module","doc":"Mix task helpers"},{"ref":"Mix.Bonny.html#app_dir_name/0","title":"Mix.Bonny.app_dir_name/0","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Bonny.html#app_name/0","title":"Mix.Bonny.app_name/0","module":"Mix.Bonny","type":"function","doc":"Get the OTP app name"},{"ref":"Mix.Bonny.html#no_umbrella!/0","title":"Mix.Bonny.no_umbrella!/0","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Bonny.html#parse_args/3","title":"Mix.Bonny.parse_args/3","module":"Mix.Bonny","type":"function","doc":"Parse CLI input"},{"ref":"Mix.Bonny.html#render/2","title":"Mix.Bonny.render/2","module":"Mix.Bonny","type":"function","doc":"Render text to a file. Special handling for the path &quot;-&quot; will render to STDOUT"},{"ref":"Mix.Bonny.html#template/1","title":"Mix.Bonny.template/1","module":"Mix.Bonny","type":"function","doc":""},{"ref":"Mix.Tasks.Bonny.Gen.Controller.html","title":"Mix.Tasks.Bonny.Gen.Controller","module":"Mix.Tasks.Bonny.Gen.Controller","type":"task","doc":"Generates a new CRD controller An operator can have multiple controllers. Each controller handles the lifecycle of a custom resource. By default controllers are generated in the V1 version scope. mix bonny.gen.controller Widget widget You can specify the version flag to create a new version of a controller. Bonny will dispatch the controller for the given version. So old versions of resources can live alongside new versions. mix bonny.gen.controller Widget widget --version v2alpha1 Note: The one restriction with versions is that they will be camelized into a module name. Open up your controller and add functionality for your resoures lifecycle: Add Modify Delete Each controller can create multiple resources. For example, a todo app controller could deploy a Deployment and a Service."},{"ref":"Mix.Tasks.Bonny.Gen.Controller.html#run/1","title":"Mix.Tasks.Bonny.Gen.Controller.run/1","module":"Mix.Tasks.Bonny.Gen.Controller","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html","title":"Mix.Tasks.Bonny.Gen.Dockerfile","module":"Mix.Tasks.Bonny.Gen.Dockerfile","type":"task","doc":"Generates a Dockerfile for this operator"},{"ref":"Mix.Tasks.Bonny.Gen.Dockerfile.html#run/1","title":"Mix.Tasks.Bonny.Gen.Dockerfile.run/1","module":"Mix.Tasks.Bonny.Gen.Dockerfile","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Bonny.Gen.Manifest.html","title":"Mix.Tasks.Bonny.Gen.Manifest","module":"Mix.Tasks.Bonny.Gen.Manifest","type":"task","doc":"Generates the Kubernetes YAML manifest for this operator mix bonny.gen.manifest expects a docker image name if deploying to a cluster. You may optionally provide a namespace. Examples The image switch is required. Options: --image (docker image to deploy) --namespace (of service account and deployment; defaults to &quot;default&quot;) --out (path to save manifest; defaults to &quot;manifest.yaml&quot;) Deploying to kubernetes: docker build -t $(YOUR_IMAGE_URL) . docker push $(YOUR_IMAGE_URL) mix bonny.gen.manifest --image $(YOUR_IMAGE_URL):latest --namespace default kubectl apply -f manifest.yaml -n default To skip the deployment for running an operator outside of the cluster (like in development) simply omit the --image flag: mix bonny.gen.manifest"},{"ref":"Mix.Tasks.Bonny.Gen.Manifest.html#run/1","title":"Mix.Tasks.Bonny.Gen.Manifest.run/1","module":"Mix.Tasks.Bonny.Gen.Manifest","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"readme.html","title":"Bonny: Kubernetes Development Framework","module":"readme","type":"extras","doc":"Bonny: Kubernetes Development Framework Extend the Kubernetes API with Elixir. Bonny make it easy to create Kubernetes Operators, Controllers, and Custom Schedulers. If Kubernetes CRDs and controllers are new to you, read up on the terminology."},{"ref":"readme.html#tutorials-and-examples","title":"Bonny: Kubernetes Development Framework - Tutorials and Examples:","module":"readme","type":"extras","doc":"Important! These tutorials are for an older version of Bonny, but the add/1, modify/1, and delete/1 APIs are the same, as well as a new reconcile/1 function. Additionally a k8s has been added! Feel free to message me on twitter if you need any help! HelloOperator Tutorial Part: 1 2 3 HelloOperator source code"},{"ref":"readme.html#talks","title":"Bonny: Kubernetes Development Framework - Talks","module":"readme","type":"extras","doc":"Commandeering Kubernetes @ The Big Elixir 2019 slides source code video"},{"ref":"readme.html#example-operators-built-with-bonny","title":"Bonny: Kubernetes Development Framework - Example Operators built with Bonny","module":"readme","type":"extras","doc":"Eviction Operator - Bonny v 0.4 Hello Operator - Bonny v 0.2"},{"ref":"readme.html#installation","title":"Bonny: Kubernetes Development Framework - Installation","module":"readme","type":"extras","doc":"Bonny can be installed by adding bonny to your list of dependencies in mix.exs: def deps do [ {:bonny, &quot;~&gt; 0.4&quot;} ] end Configuration Bonny uses the k8s client under the hood. The only configuration parameters required are :bonny controllers and a :k8s cluster: config :k8s, clusters: %{ default: %{ # `default` here must match `cluster_name` below conf: &quot;~/.kube/config&quot; } } config :bonny, # Add each CRD Controller module for this operator to load here # Defaults to none. This *must* be set. controllers: [ MyApp.Controllers.V1.WebServer, MyApp.Controllers.V1.Database, MyApp.Controllers.V1.Memcached ], # K8s.Cluster to use, defaults to :default cluster_name: :default, # Set the Kubernetes API group for this operator. # This can be overwritten using the @group attribute of a controller group: &quot;your-operator.example.com&quot;, # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name operator_name: &quot;your-operator&quot;, # Name must only consist of only lowercase letters and hyphens. # Defaults to hyphenated mix app name service_account_name: &quot;your-operator&quot;, # Labels to apply to the operator&#39;s resources. labels: %{ &quot;kewl&quot;: &quot;true&quot; }, # Operator deployment resources. These are the defaults. resources: %{ limits: %{cpu: &quot;200m&quot;, memory: &quot;200Mi&quot;}, requests: %{cpu: &quot;200m&quot;, memory: &quot;200Mi&quot;} } When configuring bonny to run in your cluster the mix bonny.gen.manifest command will generate a service account for you. To use that service account configure the k8s library like the following: config :k8s, clusters: %{ default: %{} } This will add a cluster named default. When no configuration information is provided, the k8s library will use the service account of the pod."},{"ref":"readme.html#bonny-generators","title":"Bonny: Kubernetes Development Framework - Bonny Generators","module":"readme","type":"extras","doc":"There are a number of generators to help create a kubernetes operator. mix help | grep bonny Generating an operator controller An operator can have multiple controllers. Each controller handles the lifecycle of a custom resource. By default controllers are generated in the V1 version scope. mix bonny.gen.controller Widget widgets You can specify the version flag to create a new version of a controller. Bonny will dispatch the controller for the given version. So old versions of resources can live alongside new versions. mix bonny.gen.controller Widget widgets --version v2alpha1 Note: The one restriction with versions is that they will be camelized into a module name. Open up your controller and add functionality for your resource&#39;s lifecycles: Add Modify Delete Reconcile; periodically called with each every instance of a CRD&#39;s resources Each controller can create multiple resources. For example, a todo app controller could deploy a Deployment and a Service. Your operator can also have multiple controllers if you want to support multiple resources in your operator! Check out the two test controllers: Cog Widget Generating a dockerfile The following command will generate a dockerfile for your operator. This will need to be pushed to a docker repository that your kubernetes cluster can access. Again, this Dockerfile is for your operator, not for the pods your operator may deploy. You can skip this step when developing by running your operator external to the cluster. mix bonny.gen.dockerfile export BONNY_IMAGE=YOUR_IMAGE_NAME_HERE docker build -t ${BONNY_IMAGE} . docker push ${BONNY_IMAGE}:latest Generating Kubernetes manifest for operator This will generate the entire manifest for this operator including: CRD manifests RBAC Service Account Operator Deployment The operator manifest generator requires the image flag to be passed if you plan to deploy the operator in your cluster. This is the docker image URL of your operators docker image created by mix bonny.gen.docker above. mix bonny.gen.manifest --image ${BONNY_IMAGE} You may omit the --image flag if you want to generate a manifest without the deployment so that you can develop locally running the operator outside of the cluster. Note: YAML output is JSON formatted YAML. Sorry, elixirland isn&#39;t fond of YAML :D By default the manifest will generate the service account and deployment in the &quot;default&quot; namespace. To set the namespace explicitly: mix bonny.gen.manifest --out - -n test Alternatively you can apply it directly to kubectl: mix bonny.gen.manifest --out - -n test | kubectl apply -f - -n test Generating a resource TODO: Need to support validation / OpenAPI. https://github.com/coryodaniel/bonny/issues/9 https://github.com/coryodaniel/bonny/issues/10"},{"ref":"readme.html#telemetry","title":"Bonny: Kubernetes Development Framework - Telemetry","module":"readme","type":"extras","doc":"Bonny uses the telemetry and notion library to emit event metrics. Events: Bonny.Sys.Event.events() [ [:bonny, :scheduler, :binding, :failed], [:bonny, :scheduler, :binding, :succeeded], [:bonny, :scheduler, :nodes, :fetch, :failed], [:bonny, :scheduler, :nodes, :fetch, :succeeded], [:bonny, :scheduler, :pods, :fetch, :failed], [:bonny, :scheduler, :pods, :fetch, :succeeded], [:bonny, :reconciler, :genserver, :down], [:bonny, :reconciler, :reconcile, :failed], [:bonny, :reconciler, :reconcile, :succeeded], [:bonny, :reconciler, :run, :started], [:bonny, :reconciler, :fetch, :failed], [:bonny, :reconciler, :fetch, :succeeded], [:bonny, :reconciler, :initialized], [:bonny, :watcher, :genserver, :down], [:bonny, :watcher, :chunk, :received], [:bonny, :watcher, :watch, :timedout], [:bonny, :watcher, :watch, :failed], [:bonny, :watcher, :watch, :finished], [:bonny, :watcher, :watch, :succeeded], [:bonny, :watcher, :watch, :started], [:bonny, :watcher, :initialized] ]"},{"ref":"readme.html#terminology","title":"Bonny: Kubernetes Development Framework - Terminology","module":"readme","type":"extras","doc":"Custom Resource: A custom resource is an extension of the Kubernetes API that is not necessarily available on every Kubernetes cluster. In other words, it represents a customization of a particular Kubernetes installation. CRD Custom Resource Definition: The CustomResourceDefinition API resource allows you to define custom resources. Defining a CRD object creates a new custom resource with a name and schema that you specify. The Kubernetes API serves and handles the storage of your custom resource. Controller: A custom controller is a controller that users can deploy and update on a running cluster, independently of the cluster’s own lifecycle. Custom controllers can work with any kind of resource, but they are especially effective when combined with custom resources. The Operator pattern is one example of such a combination. It allows developers to encode domain knowledge for specific applications into an extension of the Kubernetes API. Operator: A set of application specific controllers deployed on Kubernetes and managed via kubectl and the Kubernetes API."},{"ref":"readme.html#docs","title":"Bonny: Kubernetes Development Framework - Docs","module":"readme","type":"extras","doc":"Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/bonny."},{"ref":"readme.html#testing","title":"Bonny: Kubernetes Development Framework - Testing","module":"readme","type":"extras","doc":"mix test"},{"ref":"readme.html#operator-blog-posts","title":"Bonny: Kubernetes Development Framework - Operator Blog Posts","module":"readme","type":"extras","doc":"Why Kubernetes Operators are a game changer"},{"ref":"changelog.html","title":"Changelog","module":"changelog","type":"extras","doc":"Changelog All notable changes to this project will be documented in this file. The format is based on Keep a Changelog, and this project adheres to Semantic Versioning."},{"ref":"changelog.html#0-4-1-2019-11-26","title":"Changelog - [0.4.1] - 2019-11-26","module":"changelog","type":"extras","doc":"Added Support for reconciling/watching core resources"},{"ref":"changelog.html#0-4-0-2019-10-23","title":"Changelog - [0.4.0] - 2019-10-23","module":"changelog","type":"extras","doc":"Added Basic integration w/ Notion for telemetry Bonny.Server.Reconciler continually process a list operation Bonny.Server.Scheduler write custom kubernetes schedulers Added Bonny.PeriodicTask for scheduling periodically executed functions Changed Dockerfile gen uses OTP releases Removed Removed reconcile_batch_size"},{"ref":"changelog.html#0-3-3-2019-06-25","title":"Changelog - [0.3.3] - 2019-06-25","module":"changelog","type":"extras","doc":"Added Add additional printer columns Bonny.Naming module .credo.exs"},{"ref":"changelog.html#0-3-2-2019-04-15","title":"Changelog - [0.3.2] - 2019-04-15","module":"changelog","type":"extras","doc":"Added Bonny.Watcher and Bonny.Reconciler telemetry events"},{"ref":"changelog.html#0-3-1-2019-04-11","title":"Changelog - [0.3.1] - 2019-04-11","module":"changelog","type":"extras","doc":"Added Support for a reconcile/1 callback reconcile_every config option to schedule how often to run reconciliation reconcile_batch_size to set the size of the HTTP GET limit when fetching batches of items to reconcile Added {:error, binary} as a return value of Controller lifecycle methods Implemented :telemetry library Bonny.Sys.Event.events/0 exposes list of telemetry events mix bonny.gen.manifest --local for building manifests w/o a Deployment for local testing cluster_name: :default config options. Now uses k8s cluster registration configuration. Changed Async watcher event dispatch Replaced HTTPoison with k8s Fixed Receiving :DOWN messages no longer crashes Watcher #20 Issue with partially received events #43 Fix invalid singular name generation from module names &quot;MyMod&quot; -&gt; my_mod; &quot;MyMod&quot; -&gt; mymod Removed Renamed group_version -&gt; api_version Renamed Bonny.CRD.plural/1 -&gt; Bonny.CRD.kind/1 Bypass from test suite Impl.parse_metadata/1 kubeconf_file and kubeconf_opts config options"},{"ref":"changelog.html#0-3-0-2019-03-04","title":"Changelog - [0.3.0] - 2019-03-04","module":"changelog","type":"extras","doc":"Changed Replaced k8s_conf library with k8s."},{"ref":"changelog.html#0-2-3-2019-01-13","title":"Changelog - [0.2.3] - 2019-01-13","module":"changelog","type":"extras","doc":"Added Initial public release. Controller lifecycle implementation. CRD Watcher. mix task: controller generator mix task: dockerfile generator mix task: k8s manifest generator"}]